// [ (PC98) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*26*154];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(&buff[_offset], 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d;
	char id[] = ":melroonPC-9801";

	struct fpos md[] =
	{
		{ 0x15, 0x05, 0x0900 }, //
		{ 0x15, 0x0e, 0x0700 }, //
		{ 0x15, 0x15, 0x0700 }, //
		{ 0x16, 0x02, 0x0b00 }, //
		{ 0x16, 0x0d, 0x0c00 }, //
		{ 0x16, 0x19, 0x0d00 }, //
		{ 0x17, 0x0c, 0x0800 }, //
		{ 0x5b, 0x01, 0x0200 }, //
		{ 0x5b, 0x03, 0x0800 }, //
		{ 0x5b, 0x0b, 0x0700 }, //
		{ 0x5b, 0x12, 0x0600 }, //
		{ 0x5b, 0x18, 0x0700 }, //
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x1a);
		// fBXN
		disk.ReadDATA1(0x01, 0x00, 0x01, 0x01, 0x01, buff, 0x100);
		if (!memcmp(&buff[1], id, sizeof(id)-1))
		{
			fprintf(stderr, "Disk %c F܂.\n",buff[0]);
			if (buff[0]=='A')
			{
				fcut("PROG", 0x96, 0x4b, 0x00, 0x01, 0x01, 0x0000, 0x5800);
				fcut("DATA", 0x0c, 0x06, 0x00, 0x16, 0x01, 0x0000, 0x1000);
				for (i=0; md[i].size; i++)
				{
					sprintf(fname,"MUS%02d",i);
					fcut(fname, md[i].trk, md[i].trk>>1, md[i].trk&1, md[i].sec, 0x01, 0x0000, md[i].size);
				}
			}
		}
	}
	return 0;
}

